package provaintermedia;

import javax.swing.*;
import java.awt.*;
import java.net.*;
import java.io.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Lorenzo Masetti
 * @version 1.0
 */

public class AstaClient {
  private ClientManager cm;


  public AstaClient(int port) {
    try {
      cm = new ClientManager("127.0.0.1", port, this);
    } catch (UnknownHostException e) {
      e.printStackTrace();
    } catch (IOException e) {
      e.printStackTrace();
    }
  }

  public void start() {
    String nome = JOptionPane.showInputDialog("Inserisci il nome");
    cm.login(nome);

    Object[] options = {"Mando un messaggio per vendere",
        "Aspetto"
    };
    int scelta = JOptionPane.showOptionDialog(null,"Cosa vuoi fare?","Scegli",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,null,options,options[1]);
    if (scelta==0) {
      Articolo nuovo = new Articolo(123,"Enciclopedia Treccani");
      cm.sendMessage(Messaggio.messaggioArticolo(nuovo,(float) 10000));
    }

    while (true) {

    }
  }

  public void manageMessage(Messaggio m) {
    if (m!=null) {
      System.out.println(m);
    } else {
      return;
    }

    if (m.getCodice()==Messaggio.OFFERTA) {
      System.out.println("Viene offerto questo articolo:");
      Articolo offerto = (Articolo) m.getMessaggio();
      System.out.println(offerto.getDescrizione());
      System.out.println("Al prezzo di " + m.getPrezzo());
      Object[] options = {
          "faccio un'offerta",
          "Rifiuto"
      };
      int scelta = JOptionPane.showOptionDialog(null, offerto.getDescrizione() + " per " + m.getPrezzo() ,
                                                "Scegli",
                                                JOptionPane.YES_NO_OPTION,
                                                JOptionPane.QUESTION_MESSAGE, null,
                                                options, options[1]);

      if (scelta == 0) {
        float prezzo = Float.parseFloat(JOptionPane.showInputDialog("Quanto offri?"));
        cm.sendMessage(Messaggio.messaggioOfferta(offerto,prezzo));
      } else {
        cm.sendMessage(Messaggio.messaggioRifiuto());
      }
    }
  }

  //Main method
  public static void main(String[] args) {
    if (args.length != 1) {
     System.err.println(
         "Devi specificare una porta come paramentro");
     System.exit(1);
   }

   try {
     int port = Integer.parseInt(args[0]);
     new AstaClient(port).start();
   }
   catch (NumberFormatException e) {
     System.err.println(
         "Devi specificare una porta come paramentro");
     System.exit(1);
   }

  }
}