package provaintermedia;
import java.net.*;
import java.io.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Lorenzo Masetti
 * @version 1.0
 */

public class ClientManager {
  private Socket clientSocket;
  private ObjectOutputStream oos;

  public ClientManager(String host, int port,AstaClient client) throws IOException,UnknownHostException {
    clientSocket = new Socket(host,port);
    oos = new ObjectOutputStream(clientSocket.getOutputStream());
    new Thread( new Waiter(client) ).start();
  }

  public void sendMessage(Messaggio m) {
    try {
      oos.writeObject(m);
    } catch (IOException e) {
        e.printStackTrace();
    }

  }

  public void login(String name) {
    sendMessage(Messaggio.messaggioLogin(name));
  }


  class Waiter
      implements Runnable {
    private AstaClient client;
    private boolean run = true;

    public Waiter(AstaClient cl) {
      client = cl;
    }

    public void run() {
      while (run) {
        try {
          ObjectInputStream ois = new ObjectInputStream(clientSocket.
              getInputStream());
          Object m = ois.readObject();
          if (m instanceof Messaggio)
            client.manageMessage( (Messaggio) m);
        }
        catch (IOException e) {
          e.printStackTrace();
        }
        catch (ClassNotFoundException e) {
          e.printStackTrace();
        }
      }
    }

    public void stop() {
      run = false;
    }
  }

}